#include <cv.h>
#include <stdio.h>

#include <math.h>

#include <highgui.h>
#include "corner.h"

#define CORNER_MIN_DIS 15
#define CORNER_QUALITY 0.01

static double CornerMinDis = CORNER_MIN_DIS;
static double CornerQuality = CORNER_QUALITY;

int cvMyFeatureDetection(IplImage *img,CvPoint2D32f *corners,int *num){
  // 特徴点列を検出する
  // cvGoodFeaturesToTrack使用
  // img : 入力画像
  // corner : 結果を格納する領域，あらかじめ確保する必用あり
  // num : 検出された特徴点数を格納，初期値には corners の数を入れる
  
  IplImage *gray,*eig,*temp;
  // グレイ画像作成
  gray = cvCreateImage(cvGetSize(img),IPL_DEPTH_8U,1);
  if (img->nChannels==3)
    // カラー画像の場合
    cvCvtColor(img,gray,CV_BGR2GRAY);
  else 
    // グレイ画像の場合
    cvCopy(img,gray,NULL);
  
  eig = cvCreateImage(cvGetSize(gray),IPL_DEPTH_32F,1);  
  temp = cvCreateImage(cvGetSize(gray),IPL_DEPTH_32F,1);  

  cvGoodFeaturesToTrack(gray,eig,temp,corners,num,
			CornerQuality,CornerMinDis,
			NULL,3,0,0.04);
  
  cvReleaseImage(&gray);
  cvReleaseImage(&eig);
  cvReleaseImage(&temp);

  return 0;
}
