#ifndef LINEAR_H
#define LINEAR_H

#ifdef __cplusplus
extern "C"{
#endif


  /* 最小固有値に対応する固有ベクトルを返す */
  int cvGetMinEigenVector(CvMat *M,
			  CvMat *ret_vector);


  /* epsilon tensor を作成 */
  CvMatND *cvCreateTensorEpsilon(int dim);

  /* 点列を平均0, 平均からの距離の平均 sqrt(2) に正規化する */
  int cvPointNormalize(const CvMat *point,
		       CvMat *normalize,
		       CvMat *affine);
  
  /* ベクトルのノルムが1となるように正規化 */
  int cvVecNormalizeL2(CvMat *vec);

#ifdef __cplusplus
}
#endif

#endif
