#ifndef POLYGON_H
#define POLYGON_H

// 3点組を取り扱うためのポリゴンに関する記述

#include "trifocal_tensor.h"

#ifdef __cplusplus
extern "C"{
#endif

#define POL_POINT 3
  
  // 三角パッチを表現
  typedef struct{
    int num;
    CvMyCorrespond corr[POL_POINT];
  }CvMyTriangle;
  
  CvMyTriangle *makeTriangleSetByDelaunay(int cornum,CvMat *inlier,
					  int useimage,
					  CvMyCorrespond *correspond,
					  int *trinum);
  // 対応点組から三角パッチ群を作成
  // ドロネー網に関する関数を使用
  
  // cornum : 対応点の組数
  // usepoint : 使用する画像の番号
  // correspond : 対応点の集合
  
#ifdef __cplusplus
}
#endif

#endif
